<?php
/* Autor...:  */
/* Esquema.: VTA_Vendedor.xml */
/* Generado: 2021-09-14 19:26:57 */

/* Metodos de acceso a los campos de la tabla VTA_Vendedor */
abstract class BaseVTA_VendedorBN
{
    /* Campos de la tabla */
    private $i_IdPersona;    // IdPersona: ( no definido )
    private $f_PorcentajeDscto;    // PorcentajeDscto: ( no definido )
    private $s_IdUsuario;    // IdUsuario: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdPersona */
    public function setIdPersona( $i_IdPersona )
    {
        $this->i_IdPersona = $i_IdPersona;
    }

    /* Obtiene el valor del campo IdPersona */
    public function getIdPersona()
    {
        return $this->i_IdPersona;
    }

    /* Establece el valor del campo PorcentajeDscto */
    public function setPorcentajeDscto( $f_PorcentajeDscto )
    {
        $this->f_PorcentajeDscto = $f_PorcentajeDscto;
    }

    /* Obtiene el valor del campo PorcentajeDscto */
    public function getPorcentajeDscto()
    {
        return $this->f_PorcentajeDscto;
    }

    /* Establece el valor del campo IdUsuario */
    public function setIdUsuario( $s_IdUsuario )
    {
        $this->s_IdUsuario = $s_IdUsuario;
    }

    /* Obtiene el valor del campo IdUsuario */
    public function getIdUsuario()
    {
        return $this->s_IdUsuario;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdPersona' => $this->getIdPersona(),
            'PorcentajeDscto' => $this->getPorcentajeDscto(),
            'IdUsuario' => $this->getIdUsuario(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto VTA_VendedorBN desde un RecordSet */
    public static function retrieveByRs( $o_VTA_VendedorRs )
    {
        $o_VTA_VendedorBN = new VTA_VendedorBN();
        $o_VTA_VendedorBN->setIdPersona( ( integer ) $o_VTA_VendedorRs[ "IdPersona" ] );
        $o_VTA_VendedorBN->setPorcentajeDscto( ( float ) $o_VTA_VendedorRs[ "PorcentajeDscto" ] );
        $o_VTA_VendedorBN->setIdUsuario( $o_VTA_VendedorRs[ "IdUsuario" ] );
        $o_VTA_VendedorBN->setEstado( $o_VTA_VendedorRs[ "Estado" ] );
        $o_VTA_VendedorBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_VTA_VendedorRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_VTA_VendedorBN->setUsuarioCreacion( $o_VTA_VendedorRs[ "UsuarioCreacion" ] );
        $o_VTA_VendedorBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_VTA_VendedorRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_VTA_VendedorBN->setUsuarioModificacion( $o_VTA_VendedorRs[ "UsuarioModificacion" ] );
        return $o_VTA_VendedorBN;
    }
}
?>